package com.liquidnet.service.account.wallet.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.time.LocalDateTime;
import java.util.List;

public class FinBizTransExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FinBizTransExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andTransNoIsNull() {
            addCriterion("FBT0 is null");
            return (Criteria) this;
        }

        public Criteria andTransNoIsNotNull() {
            addCriterion("FBT0 is not null");
            return (Criteria) this;
        }

        public Criteria andTransNoEqualTo(String value) {
            addCriterion("FBT0 =", value, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoNotEqualTo(String value) {
            addCriterion("FBT0 <>", value, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoGreaterThan(String value) {
            addCriterion("FBT0 >", value, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoGreaterThanOrEqualTo(String value) {
            addCriterion("FBT0 >=", value, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoLessThan(String value) {
            addCriterion("FBT0 <", value, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoLessThanOrEqualTo(String value) {
            addCriterion("FBT0 <=", value, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoLike(String value) {
            addCriterion("FBT0 like", value, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoNotLike(String value) {
            addCriterion("FBT0 not like", value, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoIn(List<String> values) {
            addCriterion("FBT0 in", values, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoNotIn(List<String> values) {
            addCriterion("FBT0 not in", values, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoBetween(String value1, String value2) {
            addCriterion("FBT0 between", value1, value2, "transNo");
            return (Criteria) this;
        }

        public Criteria andTransNoNotBetween(String value1, String value2) {
            addCriterion("FBT0 not between", value1, value2, "transNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoIsNull() {
            addCriterion("FBT1 is null");
            return (Criteria) this;
        }

        public Criteria andWalletNoIsNotNull() {
            addCriterion("FBT1 is not null");
            return (Criteria) this;
        }

        public Criteria andWalletNoEqualTo(String value) {
            addCriterion("FBT1 =", value, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoNotEqualTo(String value) {
            addCriterion("FBT1 <>", value, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoGreaterThan(String value) {
            addCriterion("FBT1 >", value, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoGreaterThanOrEqualTo(String value) {
            addCriterion("FBT1 >=", value, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoLessThan(String value) {
            addCriterion("FBT1 <", value, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoLessThanOrEqualTo(String value) {
            addCriterion("FBT1 <=", value, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoLike(String value) {
            addCriterion("FBT1 like", value, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoNotLike(String value) {
            addCriterion("FBT1 not like", value, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoIn(List<String> values) {
            addCriterion("FBT1 in", values, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoNotIn(List<String> values) {
            addCriterion("FBT1 not in", values, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoBetween(String value1, String value2) {
            addCriterion("FBT1 between", value1, value2, "walletNo");
            return (Criteria) this;
        }

        public Criteria andWalletNoNotBetween(String value1, String value2) {
            addCriterion("FBT1 not between", value1, value2, "walletNo");
            return (Criteria) this;
        }

        public Criteria andFinIdIsNull() {
            addCriterion("FBT2 is null");
            return (Criteria) this;
        }

        public Criteria andFinIdIsNotNull() {
            addCriterion("FBT2 is not null");
            return (Criteria) this;
        }

        public Criteria andFinIdEqualTo(String value) {
            addCriterion("FBT2 =", value, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdNotEqualTo(String value) {
            addCriterion("FBT2 <>", value, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdGreaterThan(String value) {
            addCriterion("FBT2 >", value, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdGreaterThanOrEqualTo(String value) {
            addCriterion("FBT2 >=", value, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdLessThan(String value) {
            addCriterion("FBT2 <", value, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdLessThanOrEqualTo(String value) {
            addCriterion("FBT2 <=", value, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdLike(String value) {
            addCriterion("FBT2 like", value, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdNotLike(String value) {
            addCriterion("FBT2 not like", value, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdIn(List<String> values) {
            addCriterion("FBT2 in", values, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdNotIn(List<String> values) {
            addCriterion("FBT2 not in", values, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdBetween(String value1, String value2) {
            addCriterion("FBT2 between", value1, value2, "finId");
            return (Criteria) this;
        }

        public Criteria andFinIdNotBetween(String value1, String value2) {
            addCriterion("FBT2 not between", value1, value2, "finId");
            return (Criteria) this;
        }

        public Criteria andAmountIsNull() {
            addCriterion("FBT3 is null");
            return (Criteria) this;
        }

        public Criteria andAmountIsNotNull() {
            addCriterion("FBT3 is not null");
            return (Criteria) this;
        }

        public Criteria andAmountEqualTo(BigDecimal value) {
            addCriterion("FBT3 =", value, "amount");
            return (Criteria) this;
        }

        public Criteria andAmountNotEqualTo(BigDecimal value) {
            addCriterion("FBT3 <>", value, "amount");
            return (Criteria) this;
        }

        public Criteria andAmountGreaterThan(BigDecimal value) {
            addCriterion("FBT3 >", value, "amount");
            return (Criteria) this;
        }

        public Criteria andAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("FBT3 >=", value, "amount");
            return (Criteria) this;
        }

        public Criteria andAmountLessThan(BigDecimal value) {
            addCriterion("FBT3 <", value, "amount");
            return (Criteria) this;
        }

        public Criteria andAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("FBT3 <=", value, "amount");
            return (Criteria) this;
        }

        public Criteria andAmountIn(List<BigDecimal> values) {
            addCriterion("FBT3 in", values, "amount");
            return (Criteria) this;
        }

        public Criteria andAmountNotIn(List<BigDecimal> values) {
            addCriterion("FBT3 not in", values, "amount");
            return (Criteria) this;
        }

        public Criteria andAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("FBT3 between", value1, value2, "amount");
            return (Criteria) this;
        }

        public Criteria andAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("FBT3 not between", value1, value2, "amount");
            return (Criteria) this;
        }

        public Criteria andTransTypeIsNull() {
            addCriterion("FBT4 is null");
            return (Criteria) this;
        }

        public Criteria andTransTypeIsNotNull() {
            addCriterion("FBT4 is not null");
            return (Criteria) this;
        }

        public Criteria andTransTypeEqualTo(String value) {
            addCriterion("FBT4 =", value, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeNotEqualTo(String value) {
            addCriterion("FBT4 <>", value, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeGreaterThan(String value) {
            addCriterion("FBT4 >", value, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeGreaterThanOrEqualTo(String value) {
            addCriterion("FBT4 >=", value, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeLessThan(String value) {
            addCriterion("FBT4 <", value, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeLessThanOrEqualTo(String value) {
            addCriterion("FBT4 <=", value, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeLike(String value) {
            addCriterion("FBT4 like", value, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeNotLike(String value) {
            addCriterion("FBT4 not like", value, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeIn(List<String> values) {
            addCriterion("FBT4 in", values, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeNotIn(List<String> values) {
            addCriterion("FBT4 not in", values, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeBetween(String value1, String value2) {
            addCriterion("FBT4 between", value1, value2, "transType");
            return (Criteria) this;
        }

        public Criteria andTransTypeNotBetween(String value1, String value2) {
            addCriterion("FBT4 not between", value1, value2, "transType");
            return (Criteria) this;
        }

        public Criteria andTransStatusIsNull() {
            addCriterion("FBT5 is null");
            return (Criteria) this;
        }

        public Criteria andTransStatusIsNotNull() {
            addCriterion("FBT5 is not null");
            return (Criteria) this;
        }

        public Criteria andTransStatusEqualTo(Integer value) {
            addCriterion("FBT5 =", value, "transStatus");
            return (Criteria) this;
        }

        public Criteria andTransStatusNotEqualTo(Integer value) {
            addCriterion("FBT5 <>", value, "transStatus");
            return (Criteria) this;
        }

        public Criteria andTransStatusGreaterThan(Integer value) {
            addCriterion("FBT5 >", value, "transStatus");
            return (Criteria) this;
        }

        public Criteria andTransStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("FBT5 >=", value, "transStatus");
            return (Criteria) this;
        }

        public Criteria andTransStatusLessThan(Integer value) {
            addCriterion("FBT5 <", value, "transStatus");
            return (Criteria) this;
        }

        public Criteria andTransStatusLessThanOrEqualTo(Integer value) {
            addCriterion("FBT5 <=", value, "transStatus");
            return (Criteria) this;
        }

        public Criteria andTransStatusIn(List<Integer> values) {
            addCriterion("FBT5 in", values, "transStatus");
            return (Criteria) this;
        }

        public Criteria andTransStatusNotIn(List<Integer> values) {
            addCriterion("FBT5 not in", values, "transStatus");
            return (Criteria) this;
        }

        public Criteria andTransStatusBetween(Integer value1, Integer value2) {
            addCriterion("FBT5 between", value1, value2, "transStatus");
            return (Criteria) this;
        }

        public Criteria andTransStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("FBT5 not between", value1, value2, "transStatus");
            return (Criteria) this;
        }

        public Criteria andTradeNoIsNull() {
            addCriterion("FBT6 is null");
            return (Criteria) this;
        }

        public Criteria andTradeNoIsNotNull() {
            addCriterion("FBT6 is not null");
            return (Criteria) this;
        }

        public Criteria andTradeNoEqualTo(String value) {
            addCriterion("FBT6 =", value, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoNotEqualTo(String value) {
            addCriterion("FBT6 <>", value, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoGreaterThan(String value) {
            addCriterion("FBT6 >", value, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoGreaterThanOrEqualTo(String value) {
            addCriterion("FBT6 >=", value, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoLessThan(String value) {
            addCriterion("FBT6 <", value, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoLessThanOrEqualTo(String value) {
            addCriterion("FBT6 <=", value, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoLike(String value) {
            addCriterion("FBT6 like", value, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoNotLike(String value) {
            addCriterion("FBT6 not like", value, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoIn(List<String> values) {
            addCriterion("FBT6 in", values, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoNotIn(List<String> values) {
            addCriterion("FBT6 not in", values, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoBetween(String value1, String value2) {
            addCriterion("FBT6 between", value1, value2, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTradeNoNotBetween(String value1, String value2) {
            addCriterion("FBT6 not between", value1, value2, "tradeNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoIsNull() {
            addCriterion("FBT7 is null");
            return (Criteria) this;
        }

        public Criteria andTracingNoIsNotNull() {
            addCriterion("FBT7 is not null");
            return (Criteria) this;
        }

        public Criteria andTracingNoEqualTo(String value) {
            addCriterion("FBT7 =", value, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoNotEqualTo(String value) {
            addCriterion("FBT7 <>", value, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoGreaterThan(String value) {
            addCriterion("FBT7 >", value, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoGreaterThanOrEqualTo(String value) {
            addCriterion("FBT7 >=", value, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoLessThan(String value) {
            addCriterion("FBT7 <", value, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoLessThanOrEqualTo(String value) {
            addCriterion("FBT7 <=", value, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoLike(String value) {
            addCriterion("FBT7 like", value, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoNotLike(String value) {
            addCriterion("FBT7 not like", value, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoIn(List<String> values) {
            addCriterion("FBT7 in", values, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoNotIn(List<String> values) {
            addCriterion("FBT7 not in", values, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoBetween(String value1, String value2) {
            addCriterion("FBT7 between", value1, value2, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingNoNotBetween(String value1, String value2) {
            addCriterion("FBT7 not between", value1, value2, "tracingNo");
            return (Criteria) this;
        }

        public Criteria andTracingTypeIsNull() {
            addCriterion("FBT8 is null");
            return (Criteria) this;
        }

        public Criteria andTracingTypeIsNotNull() {
            addCriterion("FBT8 is not null");
            return (Criteria) this;
        }

        public Criteria andTracingTypeEqualTo(String value) {
            addCriterion("FBT8 =", value, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeNotEqualTo(String value) {
            addCriterion("FBT8 <>", value, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeGreaterThan(String value) {
            addCriterion("FBT8 >", value, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeGreaterThanOrEqualTo(String value) {
            addCriterion("FBT8 >=", value, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeLessThan(String value) {
            addCriterion("FBT8 <", value, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeLessThanOrEqualTo(String value) {
            addCriterion("FBT8 <=", value, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeLike(String value) {
            addCriterion("FBT8 like", value, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeNotLike(String value) {
            addCriterion("FBT8 not like", value, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeIn(List<String> values) {
            addCriterion("FBT8 in", values, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeNotIn(List<String> values) {
            addCriterion("FBT8 not in", values, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeBetween(String value1, String value2) {
            addCriterion("FBT8 between", value1, value2, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTypeNotBetween(String value1, String value2) {
            addCriterion("FBT8 not between", value1, value2, "tracingType");
            return (Criteria) this;
        }

        public Criteria andTracingTimeIsNull() {
            addCriterion("FBT9 is null");
            return (Criteria) this;
        }

        public Criteria andTracingTimeIsNotNull() {
            addCriterion("FBT9 is not null");
            return (Criteria) this;
        }

        public Criteria andTracingTimeEqualTo(LocalDateTime value) {
            addCriterion("FBT9 =", value, "tracingTime");
            return (Criteria) this;
        }

        public Criteria andTracingTimeNotEqualTo(LocalDateTime value) {
            addCriterion("FBT9 <>", value, "tracingTime");
            return (Criteria) this;
        }

        public Criteria andTracingTimeGreaterThan(LocalDateTime value) {
            addCriterion("FBT9 >", value, "tracingTime");
            return (Criteria) this;
        }

        public Criteria andTracingTimeGreaterThanOrEqualTo(LocalDateTime value) {
            addCriterion("FBT9 >=", value, "tracingTime");
            return (Criteria) this;
        }

        public Criteria andTracingTimeLessThan(LocalDateTime value) {
            addCriterion("FBT9 <", value, "tracingTime");
            return (Criteria) this;
        }

        public Criteria andTracingTimeLessThanOrEqualTo(LocalDateTime value) {
            addCriterion("FBT9 <=", value, "tracingTime");
            return (Criteria) this;
        }

        public Criteria andTracingTimeIn(List<LocalDateTime> values) {
            addCriterion("FBT9 in", values, "tracingTime");
            return (Criteria) this;
        }

        public Criteria andTracingTimeNotIn(List<LocalDateTime> values) {
            addCriterion("FBT9 not in", values, "tracingTime");
            return (Criteria) this;
        }

        public Criteria andTracingTimeBetween(LocalDateTime value1, LocalDateTime value2) {
            addCriterion("FBT9 between", value1, value2, "tracingTime");
            return (Criteria) this;
        }

        public Criteria andTracingTimeNotBetween(LocalDateTime value1, LocalDateTime value2) {
            addCriterion("FBT9 not between", value1, value2, "tracingTime");
            return (Criteria) this;
        }

        public Criteria andTracingTitleIsNull() {
            addCriterion("FBT10 is null");
            return (Criteria) this;
        }

        public Criteria andTracingTitleIsNotNull() {
            addCriterion("FBT10 is not null");
            return (Criteria) this;
        }

        public Criteria andTracingTitleEqualTo(String value) {
            addCriterion("FBT10 =", value, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleNotEqualTo(String value) {
            addCriterion("FBT10 <>", value, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleGreaterThan(String value) {
            addCriterion("FBT10 >", value, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleGreaterThanOrEqualTo(String value) {
            addCriterion("FBT10 >=", value, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleLessThan(String value) {
            addCriterion("FBT10 <", value, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleLessThanOrEqualTo(String value) {
            addCriterion("FBT10 <=", value, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleLike(String value) {
            addCriterion("FBT10 like", value, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleNotLike(String value) {
            addCriterion("FBT10 not like", value, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleIn(List<String> values) {
            addCriterion("FBT10 in", values, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleNotIn(List<String> values) {
            addCriterion("FBT10 not in", values, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleBetween(String value1, String value2) {
            addCriterion("FBT10 between", value1, value2, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingTitleNotBetween(String value1, String value2) {
            addCriterion("FBT10 not between", value1, value2, "tracingTitle");
            return (Criteria) this;
        }

        public Criteria andTracingDescIsNull() {
            addCriterion("FBT11 is null");
            return (Criteria) this;
        }

        public Criteria andTracingDescIsNotNull() {
            addCriterion("FBT11 is not null");
            return (Criteria) this;
        }

        public Criteria andTracingDescEqualTo(String value) {
            addCriterion("FBT11 =", value, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescNotEqualTo(String value) {
            addCriterion("FBT11 <>", value, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescGreaterThan(String value) {
            addCriterion("FBT11 >", value, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescGreaterThanOrEqualTo(String value) {
            addCriterion("FBT11 >=", value, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescLessThan(String value) {
            addCriterion("FBT11 <", value, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescLessThanOrEqualTo(String value) {
            addCriterion("FBT11 <=", value, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescLike(String value) {
            addCriterion("FBT11 like", value, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescNotLike(String value) {
            addCriterion("FBT11 not like", value, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescIn(List<String> values) {
            addCriterion("FBT11 in", values, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescNotIn(List<String> values) {
            addCriterion("FBT11 not in", values, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescBetween(String value1, String value2) {
            addCriterion("FBT11 between", value1, value2, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andTracingDescNotBetween(String value1, String value2) {
            addCriterion("FBT11 not between", value1, value2, "tracingDesc");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("FBT12 is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("FBT12 is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(LocalDateTime value) {
            addCriterion("FBT12 =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(LocalDateTime value) {
            addCriterion("FBT12 <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(LocalDateTime value) {
            addCriterion("FBT12 >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(LocalDateTime value) {
            addCriterion("FBT12 >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(LocalDateTime value) {
            addCriterion("FBT12 <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(LocalDateTime value) {
            addCriterion("FBT12 <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<LocalDateTime> values) {
            addCriterion("FBT12 in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<LocalDateTime> values) {
            addCriterion("FBT12 not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(LocalDateTime value1, LocalDateTime value2) {
            addCriterion("FBT12 between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(LocalDateTime value1, LocalDateTime value2) {
            addCriterion("FBT12 not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeIsNull() {
            addCriterion("FBT13 is null");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeIsNotNull() {
            addCriterion("FBT13 is not null");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeEqualTo(LocalDateTime value) {
            addCriterion("FBT13 =", value, "completeTime");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeNotEqualTo(LocalDateTime value) {
            addCriterion("FBT13 <>", value, "completeTime");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeGreaterThan(LocalDateTime value) {
            addCriterion("FBT13 >", value, "completeTime");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeGreaterThanOrEqualTo(LocalDateTime value) {
            addCriterion("FBT13 >=", value, "completeTime");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeLessThan(LocalDateTime value) {
            addCriterion("FBT13 <", value, "completeTime");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeLessThanOrEqualTo(LocalDateTime value) {
            addCriterion("FBT13 <=", value, "completeTime");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeIn(List<LocalDateTime> values) {
            addCriterion("FBT13 in", values, "completeTime");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeNotIn(List<LocalDateTime> values) {
            addCriterion("FBT13 not in", values, "completeTime");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeBetween(LocalDateTime value1, LocalDateTime value2) {
            addCriterion("FBT13 between", value1, value2, "completeTime");
            return (Criteria) this;
        }

        public Criteria andCompleteTimeNotBetween(LocalDateTime value1, LocalDateTime value2) {
            addCriterion("FBT13 not between", value1, value2, "completeTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("FBT14 is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("FBT14 is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(LocalDateTime value) {
            addCriterion("FBT14 =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(LocalDateTime value) {
            addCriterion("FBT14 <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(LocalDateTime value) {
            addCriterion("FBT14 >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(LocalDateTime value) {
            addCriterion("FBT14 >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(LocalDateTime value) {
            addCriterion("FBT14 <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(LocalDateTime value) {
            addCriterion("FBT14 <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<LocalDateTime> values) {
            addCriterion("FBT14 in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<LocalDateTime> values) {
            addCriterion("FBT14 not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(LocalDateTime value1, LocalDateTime value2) {
            addCriterion("FBT14 between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(LocalDateTime value1, LocalDateTime value2) {
            addCriterion("FBT14 not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("FBT15 is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("FBT15 is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("FBT15 =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("FBT15 <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("FBT15 >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("FBT15 >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("FBT15 <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("FBT15 <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("FBT15 like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("FBT15 not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("FBT15 in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("FBT15 not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("FBT15 between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("FBT15 not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andReasonsIsNull() {
            addCriterion("FBT16 is null");
            return (Criteria) this;
        }

        public Criteria andReasonsIsNotNull() {
            addCriterion("FBT16 is not null");
            return (Criteria) this;
        }

        public Criteria andReasonsEqualTo(String value) {
            addCriterion("FBT16 =", value, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsNotEqualTo(String value) {
            addCriterion("FBT16 <>", value, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsGreaterThan(String value) {
            addCriterion("FBT16 >", value, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsGreaterThanOrEqualTo(String value) {
            addCriterion("FBT16 >=", value, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsLessThan(String value) {
            addCriterion("FBT16 <", value, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsLessThanOrEqualTo(String value) {
            addCriterion("FBT16 <=", value, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsLike(String value) {
            addCriterion("FBT16 like", value, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsNotLike(String value) {
            addCriterion("FBT16 not like", value, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsIn(List<String> values) {
            addCriterion("FBT16 in", values, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsNotIn(List<String> values) {
            addCriterion("FBT16 not in", values, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsBetween(String value1, String value2) {
            addCriterion("FBT16 between", value1, value2, "reasons");
            return (Criteria) this;
        }

        public Criteria andReasonsNotBetween(String value1, String value2) {
            addCriterion("FBT16 not between", value1, value2, "reasons");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}
